#
# $Source: /home/nlfm/Working/Mercator/Released/lib/RCS/Chart.tcl,v $
# $Date: 1999/12/15 13:24:35 $
# $Revision: 1.1.1.24 $
#
#
package provide Chart 1.0
#
package require Node
package require Link
package require Object
package require Loader
package require Notebook
package require Style
#

#
proc Chart {args} {
    set this [::Object::makeObj Chart $args]
    namespace eval ::${this} {
	global LinkType LinkPairs
	variable linknames
	array set linknames [array get LinkTypes]
	variable linkpairs
	array set linkpairs [array get LinkPairs]
	variable showlinks
	foreach x [array names LinkTypes] {
	    set showlinks($x) 1
	}
    }
    return $this
}
#
namespace eval ::chart {
    #
    proc otherway {this dir} {
	return [set ::${this}::linkpairs($dir)]
    }
    #
    proc delete {this} {
	catch {destroy [$this window]}
	::Object::delete $this
    }
    #
    proc menuset {this which item state} {
	set w [$this window].mb.$which
	set ix [$w index $item]
	$w entryconfigure $ix -state $state
    }
    #
    proc clean {this} {
	set ::${this}::dirty 0
	$this menuset chart [mc Save] disabled
    }
    #
    proc used {this args} {
	set ::${this}::dirty 1
	$this menuset chart [mc Save] normal
    }
    #
    proc searchInit {this} {
	global prog
	if {[winfo exists [set w .search$this]]} {
	    wm deiconify $w
	    raise $w
	    return
	}
	toplevel [set w .search$this] -class $prog(Program)
	wm title $w [mc Find]
	grid [label $w.l1 -text [mc String to Find]] -sticky w -padx 5
	grid [entry $w.e1 -textvariable ::${this}::searchString] -sticky ew\
	  -padx 5
	grid [frame $w.f1] -sticky ew
	grid [radiobutton $w.f1.b1 -text [mc {Exact Match}]\
	  -variable ::${this}::searchKind -value exact] -padx 5 -row 0 -column 0
	grid [radiobutton $w.f1.b2 -text [mc {Regular Expression}]\
	  -variable ::${this}::searchKind -value regexp] -padx 5 -row 0\
	  -column 1
	grid [checkbutton $w.f1.b3 -text [mc {Ignore Case}]\
	  -variable ::${this}::searchCase] -padx 5 -row 0 -column 2
	grid [frame $w.f2] -sticky ew
	grid [checkbutton $w.f2.b1 -text [mc {Names}]\
	  -variable ::${this}::searchlabels] -padx 5 -row 0 -column 0
	grid [checkbutton $w.f2.b2 -text [mc {Notes}]\
	  -variable ::${this}::searchnotes] -padx 5 -row 0 -column 1
	grid [checkbutton $w.f2.b3 -text [mc {Fields}]\
	  -variable ::${this}::searchfields] -padx 5 -row 0 -column 2
	grid [checkbutton $w.f2.b4 -text [mc {Keywords}]\
	  -variable ::${this}::searchkeyws] -padx 5 -row 0 -column 3
	grid [frame $w.f3] -sticky ew
	grid [button $w.f3.b1 -text [mc OK] -command "
		destroy $w
		$this doSearch
	    "] -padx 5 -row 0 -column 0
	grid [button $w.f3.b3 -text [mc Cancel] -command "destroy $w"] -row 0\
	  -column 1 -padx 5
    }
    #
    proc exact0 {s1 s2} {
	return [expr {[string first $s1 $s2] >= 0}]
    }
    #
    proc regexp0 {exp s2} {
	return [regexp $exp $s2]
    }
    #
    proc exact1 {s1 s2} {
	return [expr {[string first $s1 [string tolower $s2]] >= 0}]
    }
    #
    proc regexp1 {exp s2} {
	return [regexp -nocase $exp $s2]
    }
    #
    proc doSearch {this} {
	set sd [$this showdeleted]
	set exp [$this searchString]
	set fn [$this searchKind]
	if {[set sc [$this searchCase]]} { set exp [string tolower $exp] }
	set searches {}
	if {[$this searchlabels]} { lappend searches label }
	if {[$this searchnotes]} { lappend searches notes }
	if {[$this searchfields]} { lappend searches url mail chart }
	if {[$this searchkeyw]} { lappend searches keywrods }
	foreach node [$this nodes] {
	    if {!$sd && [$node deleted]} continue
	    foreach v $searches {
		if {[$fn$sc $exp [$node $v]]} {
		    $node centre
		    return
		}
	    }
	}
    }
    #
    proc searchAgain {this} {
	unimp
    }
    #
    proc selectrem {this node} {
	if {[listdel ::${this}::selection $node]} {
	    if {[$this nodeinfo]} { $node close }
	    switch {}\
	      [$this selection] {
		    [$this last] select 0
		}
	}
    }
    #
    proc deselect {this} {
	switch {}\
	  [set sel [$this selection]] {  }\
	  default {
		set cv [$this canvas]
		foreach x $sel {
		    $cv.$x configure -bg [$this background]
		    if {[$this nodeinfo]} { $sel close }
		}
		set ::${this}::selection {}
	    }
    }
    #
    proc addSelection {this args} {
	set cv [$this canvas]
	foreach x $args {
	    raise $cv.$x
	    $cv.$x configure -bg [$this highlight]
	    lappend ::${this}::selection $x
	    if {[$this nodeinfo]} { $x open }
	}
    }
    #
    proc configure {this args} { ::Object::confObj $this $args }
    #
    proc save {this as} {
	global prog
	set types "
    {{[mc "$prog(Program) Files"]} .cht TEXT}
    {{[mc {All Files}]} *}
    "
	if {$as || [set fn [$this file]] == {}} {
	    switch {}\
	      [set fn [tk_getSaveFile -defaultextension .cht -filetypes $types\
	      -title [mc {Save File}]]] {
		    return
		}
	    set ::${this}::file $fn
	    set ::${this}::name [set bn [basename $fn]]
	    wm title [$this window] $bn
	}
	set ren 0
	if {[file exists $fn]} {
	    file rename -force $fn $fn.old
	    set ren 1
	}
	if {[catch {::open $fn w} fd]} {
	    tellError "Cannot create file \"$fn\" : $fd"
	    if {$ren} { file rename -force $fn.old $fn }
	} {
	    puts $fd "<?xml version=\"1.0\" standalone=\"yes\"?>"
	    puts $fd "<!DOCTYPE chart SYSTEM\
	      \"http://catless.ncl.ac.uk/Mercator/mercator.dtd\">"
	    puts $fd "<chart saved=\"[clock format [clock seconds] -format\
	      "%d %b %Y %H:%M:%S GMT" -gmt 1]\" mversion=\"$prog(version)\""
	    puts $fd "  last=\"[[$this last] getname]\" start=\"[[$this start]\
	      getname]\""
	    puts -nonewline $fd "  linktypes=\""
	    foreach x [$this linkTypes] {
		puts -nonewline $fd "$x [set ::${this}::linknames($x)]\
		  [set ::${this}::linkpairs($x)] "
	    }
	    puts $fd "\">"
	    switch {} [set ::${this}::styles] {} default {
		puts $fd <style>
		foreach {x y} [set ::${this}::styles] {
		    puts $fd "[set ${x}::name] {$y}"
		}
		puts $fd </style>
	    }
	    if {[catch {foreach y {links nodes} {
		    foreach x [$this $y] {$x save $fd}
		}} msg]} {
		global errorInfo
		tellError "Error saving into file \"$fn\" : $msg\n$errorInfo"
		if {$ren} { file rename -force $fn.old $fn }
	    }
	    puts $fd </chart>
	    ::close $fd
	    $this clean
	}
    }
    #
    proc addHistory {this node} {
	switch $node\
	  [lindex [$this history] end] return
	lappend ::${this}::history $node
	switch {}\
	  [set txt [$node label]] { set txt $node }
	[$this window].hist.lb insert end $txt
	set ::${this}::last $node
    }
    #
    proc show {this} {
	makeWindow $this
	switch {} [set file [$this file]] {
		set nm New
	} default {
		set nm [basename $file]
		loadChart $this $file
	}
	switch {} [$this styles] {
	    set ns [$this addStyle Normal \
	      {family:helvetica;size:12;weight:bold;foreground:blue;background:white}]
	    set ::${this}::currentstyle $ns
	    set ::${this}::sname [set ${ns}::name]
	}
	switch {} [$this nodes] {
		$this addnode [set nd [Node -label $nm -map $this]]
		set ::${this}::start $nd
		set ::${this}::last $nd
	}
	[$this last] show 1
	$this clean
	$this menuset chart [mc Close] normal
    }
    #
    proc changeInfo {this args} {
	if {[$this nodeinfo]} {
	    grid [$this window].info
	    [$this selection] open
	} {
	    [$this selection] close
	    grid remove [$this window].info
	}
    }
    #
    proc toggle {this var} {
	set ::${this}::$var [expr {![set ::${this}::$var]}]
    }
    #
    proc stashNode {this node} {
	set ::${this}::stash $node
	set ix [[$this window].mb.view index [mc {Goto Stash}]]
	[$this window].mb.view entryconfigure $ix -state normal
    }
    #
    proc gotoStash {this} {
	switch {}\
	  [set nd [$this stash]] return
	$nd centre
    }
    #
    proc makeWindow {this} {
	global Pmenus prog
	set ::${this}::window [set nm .$this]
	toplevel $nm -class $prog(Program)
	$nm configure -menu [menu $nm.mb]
	wm title $nm [$this name]
	wm protocol $nm WM_DELETE_WINDOW "Close $this"
	wm resizable $nm 1 1
	makeMenu $this 0 Pmenus {Chart Edit View Roots Windows Help}
	foreach {dir lab} [array get ::${this}::linknames] {
	    switch {}\
	      $lab continue
	    $nm.mb.view add checkbutton -label [mc $lab]\
	      -variable ::${this}::showlinks($dir)
	}
	frame $nm.hist
	if {[$this tracking]} {
	    grid $nm.hist -sticky ns
	}
	trace variable ::${this}::tracking w "$this changetrack"
	trace variable ::${this}::view w "$this changeview"
	trace variable ::${this}::showimages w "$this changeview"
	trace variable ::${this}::showlinks w "$this changeview"
	trace variable ::${this}::showalllinks w "$this changeview"
	trace variable ::${this}::showdeleted w "$this changeview"
	trace variable ::${this}::nodeinfo w "$this changeInfo"
	trace variable ::${this}::roots w "$this reroot"
	grid columnconfigure $nm.hist 0 -weight 1
	grid rowconfigure $nm.hist 0 -weight 1
	grid [listbox $nm.hist.lb -bg white -width 9 -relief sunken]\
	  -sticky ns -rowspan 2
	bind $nm.hist.lb <Double-1> "$this pickNode %W %y"
	grid columnconfigure $nm 1 -weight 1
	grid rowconfigure $nm 0 -weight 1
	set rel sunken
	if {[$this readonly]} { set rel raised }
	set cv [canvas $nm.cv -borderwidth 2 -relief $rel -width [$this width]\
	  -height [$this height] -highlightthickness 0 -background\
	  [$this background]]
	$cv bind n <ButtonPress-1> "mkLink $cv %x %y"
	$cv bind s <ButtonPress-1> "mkLink $cv %x %y"
	$cv bind e <ButtonPress-1> "mkLink $cv %x %y"
	$cv bind w <ButtonPress-1> "mkLink $cv %x %y"
#	bind $cv <$prog(popmenu)> "$this menuChart %X %Y ; break"
	set ::${this}::canvas $cv
	grid $cv -sticky nsew -row 0 -column 1
	set txt [text $nm.tx -borderwidth 2 -relief $rel -highlightthickness 0\
	  -wrap word -state disabled -bg white -fg black -width 45 -height 12]
	grid $txt -sticky nsew -row 0 -column 1
	bind $txt <$prog(popmenu)> "$this menuChart %X %Y ; break"
	grid remove $txt
	set l1 0
	set l2 10
	for {set ix 1} {$ix <= 10} {incr ix} {
	    $txt tag configure level$ix -lmargin1 $l1 -lmargin2 $l2
	    incr l1 20
	    incr l2 20
	}
	set ::${this}::text $txt
	focus $cv
	bind $cv <KeyPress> "$this keystroke \"%A\""
	bind $cv <Delete> "$this keydel ; break"
	bind $cv <BackSpace> "$this keydel ; break"
	bind $cv <Control-h> "$this keydel ; break"
	bind $cv <Tab> "$this tab ; break"
	bind $cv <Escape> { break }
	bind $cv <Return> "if {\[$this fastadd\]} { $this doreturn}"
	bind $cv <KP_Enter> { break }
	bind $cv <Control-KeyPress> { break }
	bind $cv <$prog(cmdkey)-r> "$this changeview ; break"
	bind $cv <$prog(cmdkey)-t> "set ::${this}::view tree ; break"
	bind $cv <$prog(cmdkey)-c> "set ::${this}::view centred ; break"
	bind $cv <$prog(cmdkey)-e> "set ::${this}::view outline ; break"
	bind $cv <$prog(cmdkey)-i> "$this toggle nodeinfo ; break"
	bind $cv <$prog(cmdkey)-f> "$this searchInit ; break"
	bind $cv <$prog(cmdkey)-l> "$this toggle tracking ; break"
	bind $cv <$prog(cmdkey)-g> "$this searchAgain ; break"
	bind $cv <Alt-KeyPress> { break}
	bind $cv <Meta-KeyPress> { break}
	bind $cv <Configure> "$this resize %W %w %h"
	bind $cv <Enter> {focus %W}
	grid [frame $nm.cols] -row 1 -column 1 -sticky ew
	set cl -1
	foreach x {red orange yellow green blue purple violet black white} {
	    grid [frame $nm.cols.$x -bg $x -relief ridge -bd 2\
	      -cursor spraycan] -ipadx 10 -ipady 10 -row 0 -column [incr cl]
	    bind $nm.cols.$x <1> "
		foreach wd {0 1 2 4 6 8 10} {
		$nm.cols.thick itemconfigure wd\$wd -fill $x
	    }
		set ::${this}::ink $x
	    "
	}
	grid [canvas $nm.cols.thick -width 100 -height 20] -padx 10 -row 0\
	  -column [incr cl]
	set xc 1
	foreach wd {0 1 2 4 6 8 10} {
	    $nm.cols.thick create line $xc 0 $xc 19 -width $wd -tags wd$wd\
	      -fill [$this ink]
	    incr xc 15
	    $nm.cols.thick bind wd$wd <1> "
	    set ::${this}::thick $wd
	"
	}
	foreach x [winfo children .] {
	    switch -glob .chart*\
	      $x {
		    if {[catch {$x.mb.windows index $title}]} {
			$x.mb.windows add command -label $title -command\
			  "$this popup"
		    }
		}
	}
	grid [frame $nm.info] -row 0 -column 2 -rowspan 2 -sticky ns
	grid rowconfigure $nm.info {0 1 2} -weight 0
	grid rowconfigure $nm.info 3 -weight 1
	grid columnconfigure $nm.info 0 -weight 1
	frame $nm.info.f1
	grid columnconfigure $nm.info.f1 0 -weight 1
	grid [label $nm.info.f1.lab -text [mc Name]] -row 0 -column 0 -sticky w
	grid [checkbutton $nm.info.f1.del -text [mc Deleted]\
	  -highlightthickness 0 -borderwidth 0] -row 0 -column 1 -sticky e
	grid remove $nm.info.f1.del
	grid $nm.info.f1 -sticky ew
	grid [entry $nm.info.name -width 30] -sticky ew -padx 5
	bind $nm.info.name <Return> "$this doreturn"
	grid [::Notebook::notebook $nm.info.nb Notes Fields Format Keywords]\
	  -sticky nsew
	foreach x {Notes Fields Format Keywords} {
	    conf$x $nm.info.nb $this
	}
	return $nm
    }
    #
    proc doreturn {this} {
	if {[set ::${this}::fastadd]} {
	    set nm [[$this last] buildNode s 50 50]
	    [$this last] centre
	    $nm select 0
	} {
	    [set ::${this}::window].info.name insert insert \n
	}
    }
    #
    proc tinsert {this where args} {
	set txt [$this text]
	set mode [$txt cget -state]
	$txt configure -state normal
	foreach {x y} $args {
	    $txt insert $where $x $y
	}
	$txt configure -state $mode
    }
    #
    proc tab {this} {

    }
    #
    proc access {this kind} { [$this last] setAccess $kind }
    #
    proc reroot {this args} {
	set w [$this window]
	$w.mb.roots delete 0 end
	foreach x [$this roots] {
	    switch {}\
	      [set txt [$x label]] { set txt $x }
	    $w.mb.roots add command -label $txt -command "$x centre"
	}
    }
    #
    proc addRoot {this args} {
	foreach node $args { listadd ::${this}::roots $node }
    }
    #
    proc removeRoot {this args} {
	foreach node $args {
	    listdel ::${this}::roots $node
	}
    }
    #
    proc addnode {this node} {
	lappend ::${this}::nodes $node
	set ::${this}::nameMap([$node name]) $node
	if {[$node rootless]} { $this addRoot $node }
    }
    #
    proc addlink {this link} {
	lappend ::${this}::links $link
	set ::${this}::nameMap([$link name]) $link
    }

    #
    proc changeview {this args} {
	[$this last] centre
    }
    #
    proc pickNode {this w y} {
	[lindex [$this history] [$w nearest $y]] centre
    }
    #
    proc changetrack {this args} {
	set w [$this window].hist
	if {[$this tracking]} {
	    grid $w -row 0 -column 0
	} {
	    grid remove $w
	}
    }
    #
    proc popup {this} {
	wm deiconify [$this window]
	raise [$this window]
    }
    #
    proc print {this} {
	unimp
    }
    #
    proc resize {this cv wd ht} {
	set wid [expr {$wd / [$this width]}]
	set hgt [expr {$ht / [$this height]}]
	set ::${this}::width [expr {$wd * 1.0}]
	set ::${this}::height [expr {$ht * 1.0}]
	foreach item [$this nodes] {
	    foreach {x1 y1} [$cv coords $item] {
		set nx [expr {$x1 * $wid}]
		set ny [expr {$y1 * $hgt}]
		$cv move $item [expr {$nx - $x1}] [expr {$ny - $y1}]
		break
	    }
	    foreach {x1 y1} [$cv coords h$item] {
		set nx [expr {$x1 * $wid}]
		set ny [expr {$y1 * $hgt}]
		$cv move h$item [expr {$nx - $x1}] [expr {$ny - $y1}]
		break
	    }
	}
	foreach item [$this links] {
	    if {[$item deleted]} continue
	    switch {}\
	      [$cv find withtag $item] {  }\
	      default {
		    $item show
		}
	}
    }
    #
    proc keystroke {this char} {
	switch [llength [set sel [$this selection]]]\
	  1 {
		switch -- $char {
		{} -
		{{}} {  }
		default { append ::${sel}::label $char }
		}
	    }\
	  default { bell }
    }
    #
    proc linkTypes {this} {
	return [array names ::${this}::linknames]
    }
    #
    proc keydel {this} {
	switch [llength [set sel [$this selection]]]\
	  1 {
		set txt [$sel label]
		set len [string length $txt]
		set ::${sel}::label [string range $txt 0 [expr {$len - 2}]]
	    }\
	  default { bell }
    }
    #
    proc close {this} {
	if {[$this dirty]} {
	    switch [tk_messageBox -type yesnocancel -icon question -message\
	      "Save [$this name]?" -title [mc Save]]\
	      cancel {
		    return
		}\
	      yes { $this save 0 }\
	      no {  }
	}
	$this delete
	foreach x [namespace children ::] {
	    switch -glob -- $x\
	      {::chart[0-9]*} return
	}
	Quit $this
    }
    #
    proc famShow {this node which} {
	switch {}\
	  [set links [$node links($which)]] return
	set sd [$this showdeleted]
	set dir [$this otherway $which]
	set cv [$this canvas]
	set width [$this width]
	set height [$this height]
	foreach {x1 y1 x2 y2} [$cv bbox $node] break
	set tw [expr {$x2 - $x1}]
	set th [expr {$y2 - $y1}]
	set tw2 [expr {$tw/2}]
	set th2 [expr {$th/2}]
	set row 1
	set cnt 1
	switch $dir {
	n { set cent [set x [halfit $x1 $x2]]
		set y [expr {$y2+20}]
		set ivar x
		set inc $tw }
	s { set cent [set x [halfit $x1 $x2]]
		set y [expr {$y1-20}]
		set ivar x
		set inc $tw }
	e { set row 1001
		set x [expr {$tw-30}]
		set cent [set y [halfit $y1 $y2]]
		set ivar y
		set inc $th }
	w { set row 1001
		set x [expr {round($width) -$tw+30}]
		set cent [set y [halfit $y1 $y2]]
		set ivar y
		set inc $th }
	}
	set xs $x
	foreach lk $links {
	    if {!$sd && [$lk deleted]} continue
	    [$lk otherEnd $node] show 2 $x $y $dir
	    $lk show
	    set $ivar [newpos $cent $inc $cnt $row]
	    if {[incr cnt] > $row} {
		set cnt 1
		incr row
		switch $dir {
		n { set y [expr {$y+$th2+10}]
			set x [rowpos $cent $row $tw2] }
		s { set y [expr {$y-$th2-10}]
			set x [rowpos $cent $row $tw2] }
		}
	    }
	}
    }
    #
    proc rowpos {xc row w2} {
	if {$row & 1} { return $xc }
	return [expr {$xc - $w2}]
    }
    #
    proc newpos {cent dist cnt row} {
	if {$row & 1} {
	    if {$cnt & 1} {
		return [expr {$cent-$dist*($cnt+1) /2}]
	    } {
		return [expr {$cent+$dist*$cnt/2}]
	    }
	}\
	elseif {$cnt & 1} {
	    return [expr {$cent+$dist*$cnt/2}]
	} {
	    return [expr {$cent-$dist*($cnt+1) /2}]
	}
    }
    #
    proc circshow {this node subs} {
	switch [set len [llength $subs]]\
	  0 return
	set sd [$this showdeleted]
	set width [$this width]
	set height [$this height]
	set seg [expr {(4.0*asin(1.0)) / $len}]
	foreach {x1 y1 x2 y2} [[set cv [$this canvas]] bbox $node] break
	set tw [expr {$x2 - $x1}]
	set tw2 [expr {$tw/2}]
	set th [expr {$y2 - $y1}]
	set th2 [expr {$th/2}]
	set xc $x1
	set yc $y1
	if {$width > $height} {
	    set hyp [expr {round($height) - $y2}]
	} {
	    set hyp [expr {round($width) - $x2}]
	}
	set x1 [expr {$xc + $hyp}]
	set ang 0.0
	foreach lk $subs {
	    if {!$sd && [$lk deleted]} continue
	    foreach {x1 y1 ang} [overlap $cv $height $width $th $tw $x1 $y1\
	      $ang] break
	    [$lk otherEnd $node] show 2 [expr {$x1 + $tw2}] [expr {$y1 + $th2}]
	    set ang [expr {$ang + $seg}]
	    set x1 [expr {$xc + round($hyp * cos($ang))}]
	    set y1 [expr {$yc - round($hyp * sin($ang))}]
	}
	foreach lk $subs { $lk show }
    }
    #
    proc display {this dir} {
	return [set ::${this}::showlinks($dir)]
    }
    #
    proc removeNode {this node} {
	switch $node\
	  [$this selection] {
		switch $node\
		  [$this last] {  }\
		  default {
			[$this last] select 0
		    }
	    }
	foreach var {nodes roots} {
	    listdel ::${this}::$var $node
	}
	[$this canvas] delete $node
	catch {::destroy [$this.canvas].$this}
    }
    #
    proc removeLink {this link} {
	listdel ::${this}::links $link
	[$this canvas] delete $link
    }
    #
    proc mapNames {this} {
	foreach nl [$this links] { $nl mapNames }
	set ::${this}::last [$this nameMap([$this last])]
	set ::${this}::start [$this nameMap([$this start])]
    }
    #
    proc newStyle {this nb} {
	switch {} [set ns [::Style::newStyle $this]] return
	lappend ::${this}::styles $ns
    }
    #
    proc setStyle {this nb style} {
	set ::${this}::currentstyle $style
	set ::${this}::sname [set ${style}::name]
    }
    #
    proc addStyle {this name data} {
	lappend ::${this}::styles [set nn [::Style::makeStyle $name $data]]
	return $nn
    }
    #
    proc menuChart {this x y} {
	catch {::destroy .menu$this }
	set m [menu .menu$this -tearoff 0]
 	$m add command -label [mc Centred] -command "set ::${this}::view centred"
 	$m add command -label [mc Tree] -command "set ::${this}::view tree"
 	$m add command -label [mc Outline] -command "set ::${this}::view outline"
	$m add separator
	tk_popup $m $x $y
	raise $m
    }
    #
    # End of chart namespace
    #
#
    proc exporthtml {this} {
	global prog
	set types [list\
	    [list [mc {HTML Files}] $prog(html)]\
	    [list [mc {All Files}] *]\
	  ]
	switch {} [set fn [tk_getSaveFile -defaultextension $prog(html) \
	 -filetypes $types -title [mc {HTML Output File}]]] return
	if {[catch {::open $fn w} fd]} {
	    tellError "Cannot open file \"$fn\" : $fd"
	} {
	    puts $fd "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0\
	      Transitional//EN\" \"http://www.w3.org/TR/REC-html40/loose.dtd\">"
	    puts $fd <html><head>
	    puts $fd <title>[::clean [[$this last] label]]</title>
	    puts $fd "<meta http-equiv=\"Content-Type\" content=\"text/html;\
	      charset=iso-8859-1\">"
	    puts $fd "<meta name=\"generator\" content=\"$prog(Program)\
	      $prog(version).$prog(patchlevel)\">"
	    puts $fd </head><body>
	    [$this last] html $fd 1 0
	    puts $fd </body></html>
	    ::close $fd
	}
    }
#
    proc exporttext {this} {
	set types [list\
	    [list [mc {Text Files}] .txt TEXT]\
	    [list [mc {All Files}] *]\
	  ]
	switch {} [set fn [tk_getSaveFile -defaultextension .txt \
	  -filetypes $types -title [mc {Text Output File}]]] return
	if {[catch {::open $fn w} fd]} {
	    tellError "Cannot open file \"$fn\" : $fd"
	} {
	    [$this last] text $fd 1 0
	    ::close $fd
	}
    }
#
    proc exportdot {this} {
	set types [list \
	    [list [mc {Dot Files}] .dot TEXT]\
	    [list [mc {All Files}] *]\
	  ]
	switch {} [set fn [tk_getSaveFile -defaultextension .dot \
	  -filetypes $types -title [mc {Dot Output File}]]] return
	if {[catch {::open $fn w} fd]} {
	    tellError "Cannot open file \"$fn\" : $fd"
	} {
	    global ndone
	    puts $fd "digraph \"[$this name]\" \{"
	    puts $fd "  \{\n    rank=same"
	    foreach x [$this roots] {
		puts $fd "[$x name][$x dotprops];"
	    }
	    puts $fd "  \}"
	    foreach x [$this roots] { $x dot $fd }
	    puts $fd "\}"
	    ::close $fd
	    catch {unset ndone}
	}
    }
}

