#
# $Source: /home/nlfm/Working/Mercator/Released/lib/RCS/Config.tcl,v $
# $Date: 1999/12/01 12:11:23 $
# $Revision: 1.1.1.3 $
#
# ----------------------------------------------------------------------
#   AUTHOR:  Lindsay Marshall <lindsay.marshall@newcastle.ac.uk>
# ----------------------------------------------------------------------
# Copyright 1999 The University of Newcastle upon Tyne (see COPYRIGHT)
# ======================================================================
#
#
package provide configuration 1.0
#
package require Notebook
package require http
#
proc GlobalPreferences {obj} {
    ::config::show
}
#
proc ChartPreferences {obj} {
    tellInfo "Sorry not yet implemented."
}
#
namespace eval ::config {
#
    proc show {} {
        if {[winfo exists .cnf]} {
            wm deiconify .cnf
	    raise .cnf
	    return
        }
        set w [toplevel .cnf]
	wm title $w "Mercator Preferences"
	grid rowconfigure $w 0 -weight 1
	grid columnconfigure $w 0 -weight 1
	grid [::Notebook::notebook $w.nb Comms Images Defaults] -sticky nsew
	foreach x {Comms Images Defaults} {
	    show$x $w.nb
	}
	grid [buttons $w] -sticky ew
	::Notebook::pickNote $w.nb Comms
    }
#
    proc buttons {w} {
	set f [frame $w.btn]
	set cl 0
	foreach x {save apply cancel} {
	    button $f.$x -text [mc [string totitle $x]] -width 8 -command "::config::$x $w.nb"
	    grid $f.$x -row 0 -column $cl
	    incr cl
	}
	return $w.btn
    }
#
    proc save {nb} {
        set pd [prefdir]
	set pf [file join $pd preferences]
	set ren 0
	if {[file exists $pf]} {
	    if {[catch {file rename -force $pf $pf.old} msg]} {
	        tellError "Cannot rename preferences file - \"$msg\""
	        return
	    }
	    set ren 1
	}
	if {[catch {open [file join $pd preferences] w} fd]} {
	    tellError "Cannot open preferences file - \"$msg\""
	    if {$ren} { catch {file rename $pf.old $pf} }
	    return
	}
	puts $fd "#
# Mercator Preferences - saved [clock format [clock seconds]]
#"
	foreach x {Comms Images Defaults} {
	    save$x $nb $fd
	}
	close $fd
	
    }
#
    proc apply {nb} {
	foreach x {Comms Images Defaults} {
	    apply$x $nb
	}
    }
#
    proc cancel {nb} {
        destroy [winfo parent $nb]
    }
#
    proc showComms {nb} {
        set w [::Notebook::getNote $nb Comms]
	grid columnconfigure $w 1 -weight 1
	grid [label $w.l4 -text [mc Mailer]:] -row 0 -column 0 -sticky w -pady 10
	grid [entry $w.mlr] -row 0 -column 1 -columnspan 3 -sticky ew
	$w.mlr insert end $::Comms::mailer
	grid [label $w.l5 -text [mc "Browser"]:] -row 1 -column 0 -sticky w -pady 10
	grid [entry $w.brw] -row 1 -column 1 -columnspan 3 -sticky ew
	$w.brw insert end $::Comms::browser
	grid [label $w.l1 -text [mc "Web Proxy Host"]:] -sticky w -pady 10
	grid [entry $w.prx] -row 2 -column 1 -sticky ew
	$w.prx insert end [::http::config -proxyhost]
	grid [label $w.l2 -text [mc "Web Proxy Port"]:] -sticky w -row 2 -column 2
	grid [entry $w.prt -width 4] -row 2 -column 3
	$w.prt insert end [::http::config -proxyport]
	grid [label $w.l3 -text [mc "No proxy for"]:] -row 3 -column 0 -sticky w -pady 10
	grid [entry $w.npx] -row 3 -column 1 -columnspan 3 -sticky ew
	$w.npx insert end $::Comms::noproxy
	grid [frame $w.fill] -sticky nsew
	grid rowconfigure $w 4 -weight 1
	return $w
    }
#
    proc applyComms {nb} {
        set w [::Notebook::getNote $nb Comms]
	webproxy [$w.prx get] [$w.prt get]
	webnoproxy [$w.npx get]
	browser [$w.brw get]
	mailer [$w.mlr get]
    }
#
    proc saveComms {nb fd} {
        set w [::Notebook::getNote $nb Comms]
	switch {} [set vr [$w.mlr get]] {} default {
	    puts $fd "mailer [list $vr]"
	}
	switch {} [set vr [$w.brw get]] {} default {
	    puts $fd "browser [list $vr]"
	}
        switch {} [set vr [$w.prx get]] {} default {
	    puts -nonewline $fd "webproxy [list $vr]"
	    switch {} [set vr [$w.prt get]] {} default {
	        puts -nonewline $fd " [list $vr]"
	    }
	    puts $fd {}
	}
        applyComms $nb
        switch {} [set vr [$w.npx get]] {} default {
	    puts -nonewline $fd webnoproxy
	    foreach x [split $vr { ,;}] {
	        switch {} $x continue
		puts -nonewline $fd " [list $x]"
	    }
	    puts $fd {}
	}
    }
#
    proc showImages {nb} {
        set w [::Notebook::getNote $nb Images]
	grid [label $w.not -text {Sorry, not supported yet}] -sticky ew
	grid [frame $w.filler] -sticky nsew
	grid rowconfigure $w 1 -weight 1
    }
#
    proc saveImages {nb fd} {
    }
#
    proc showDefaults {nb} {
        set w [::Notebook::getNote $nb Defaults]
	grid [label $w.not -text {Sorry, not supported yet}] -sticky ew
	grid [frame $w.filler] -sticky nsew
	grid rowconfigure $w 1 -weight 1
    }
#
    proc saveDefaults {nb fd} {
    }
#
}
