#
# $Source: /home/nlfm/Working/Mercator/Released/lib/RCS/Debug.tcl,v $
# $Date: 1998/12/08 15:53:43 $
# $Revision: 1.1.1.3 $
#
# ----------------------------------------------------------------------
#   AUTHOR:  Lindsay Marshall <lindsay.marshall@newcastle.ac.uk>
# ----------------------------------------------------------------------
# Copyright 1998 The University of Newcastle upon Tyne (see COPYRIGHT)
# ======================================================================
#
package provide mercator 1.0
#
proc zshow {line} {
    if {[winfo exists [set w .debug.txt]]} {
	$w configure -state normal
	$w insert end ">> $line\n"
	$w configure -state disabled
	$w see end
	update idletasks
    }
}
#
proc zDbgHist {inc txt ent} {
    global DBGPos
    $ent delete 0 end
    set rng [$txt tag ranges input]
    set foo [lindex $rng $DBGPos]
    switch end $DBGPos {
	switch {} $foo return
	set DBGPos [expr [llength $rng] - 1]
    }
    incr DBGPos $inc
    if {$DBGPos <= 0} { set DBGPos end }
    if {$DBGPos >= [llength $rng]} { set DBGPos 1 }
    set idx [lindex [split $foo .] 0]
    $ent insert insert [$txt get $idx.2 "$idx.0 lineend"]
}
#
proc zDbgDo {} {
    global DBGPos errorInfo
    set w .debug
    set cmd [$w.ent get]
    set res [catch {uplevel #0 $cmd} msg]
    $w.txt configure -state normal
    $w.txt insert end {% }
    $w.txt insert end $cmd input
    $w.txt insert end "\n"
    switch {} $msg {} default {$w.txt insert end "$msg\n" output}
    if {$res} {$w.txt insert end "$errorInfo\n" err}
    $w.txt configure -state disabled
    $w.ent delete 0 end
    $w.txt see end
    set DBGPos end
}
#
proc zError {msg cmd prefix param rest} {
    switch -glob -- $msg {
    {grab failed*} { bell ; return }
    }
    global errorInfo tk_patchLevel prog tcl_platform currentNet
    set file [file join [tmpdir] merc[pid]]
    set foo [open $file a]
    catch {puts $foo "------Error: mercator $prog(version) $prog(patchlevel) tcl [info patchlevel] tk $tk_patchLevel"}
    catch {puts $foo [array get tcl_platform]}
    puts $foo $errorInfo
    close $foo
    set msg  "Mercator has detected an internal error \"$msg\" when processing\
      \"$cmd\" from \"$prefix\" ($param $rest). The stack trace has\
      been saved in file \"$file\". Please send this information to\
      Lindsay.Marshall@newcastle.ac.uk."
      tellError $msg
}
#
proc tkerror {err} { zError $err INTERNAL {} {} {} }
#
proc bgerror {err} { zError $err INTERNAL {} {} {} }
