#
# $Source: /home/nlfm/Working/Mercator/Released/lib/RCS/Link.tcl,v $
# $Date: 1999/12/15 13:24:36 $
# $Revision: 1.1.1.12 $
#
package provide Link 1.0
#
package require Object
#
proc Link {args} {
    set this [::Object::makeObj Link $args]
    return $this
}
#
namespace eval ::link {
#
proc configure {this args} { ::Object::confObj $this $args }
#
proc delete {this} {
    [$this map] removeLink $this
    ::Object::delete $this
}
#
proc getname {this} {
    switch {} [set nm [$this name]] {
	set nm [set ::${this}::name $this]
    }
    return $nm
}
#
proc save {this desc} {
    global Link
    array set defs $Link
    puts -nonewline $desc "<link name=[quote [$this getname]] type=[quote [$this type]]"
    foreach x {start end} {
	puts -nonewline $desc " $x=[quote [[$this $x] getname]]"
    }
    foreach var [list style colour width access deleted] {
	switch -- [set val [set ::${this}::$var]] $defs($var) continue
	puts -nonewline $desc " $x=[quote $val]"
    }
    puts $desc {>}
    saveData $this $desc
    puts $desc </link>
}
#
proc show {this} {
    global prog
    set chrt [$this map]
    set typ [$this type]
    set mnd [$chrt last]
    set cv [$chrt canvas]
    set start [$this start]
    set end [$this end]
    if {[$this deleted]} {
	if {![$chrt showdeleted]} return
	set colour [tkDarken [$this colour] 200]
    } {
	set colour [$this colour]
    }
    switch [$chrt view] centred {
	switch $end $mnd {
	    set ss $start
	    set start $end
	    set end $ss
	    switch $typ {
	    s { set typ n }
	    e { set typ w }
	    w {set typ e }
	    }
	}
	switch {} [set bb [$cv bbox $start]] {
	puts stderr "start == $start"
	} default {
	    foreach {sx1 sy1 sx2 sy2} $bb break
	}
	switch {} [set bb [$cv bbox $end]] {
	    puts "end = $end"
	} default {
	    foreach {ex1 ey1 ex2 ey2} $bb break
	}
	
	switch $typ {
	n {set ptn gray50}
	s { set ptn {} }
	e -
	w { set ptn gray25 }
	}
	set x1 [halfit $sx1 $sx2]
	set y1 [halfit $sy1 $sy2]
 	set x2 [halfit $ex1 $ex2]
	set y2 [halfit $ey1 $ey2]
   } tree {
	foreach {sx1 sy1 sx2 sy2} [$cv bbox $start] break
	foreach {ex1 ey1 ex2 ey2} [$cv bbox $end] break
	switch $typ {
	  n {
      		set y1 $sy1
		set y2 $ey2
		set x1 [halfit $sx1 $sx2]
		set x2 [halfit $ex1 $ex2]
	    }
	  s {
      		set y1 $sy2
		set y2 $ey1
		set x1 [halfit $sx1 $sx2]
		set x2 [halfit $ex1 $ex2]	  
	    }
	  w {
      		set x1 $sx1
		set x2 $ex2
		set y1 [halfit $sy1 $sy2]
	       set y2 [halfit $ey1 $ey2]
	    }
	  e {
      		set x1 $sx2
		set x2 $ex1
		set y1 [halfit $sy1 $sy2]
		set y2 [halfit $ey1 $ey2 ]
	    }
	}
	set ptn {}
    }
    $cv delete $this
    set wd [$this width]
#    $cv create line $x1 $y1 $x2 $y2 -fill $colour \
#	-width [$this width] -tag $this -stipple $ptn -capstyle round
    $cv create polygon $x1 $y1 [expr {$x2 - $wd}] $y2 [expr {$x2 + $wd}] \
      $y2 $x1 $y1 -fill $colour -outline $colour -tag $this -splinesteps 10
    $cv bind $this <$prog(popmenu)> "$this menuLink %X %Y ; break"
#    $cv lower $this
}
#
proc menuLink {this x y} {
    catch {::destroy .menu$this}
    set m [menu .menu$this -tearoff 0]
    $m add cascade -label [mc Style]
    $m add cascade -label [mc Colour]
    $m add cascade -label [mc Width]
    $m add separator
    $m add command -label [mc Delete] -command "$this linkremove ; ::destroy $m"
    $m add command -label [mc Undelete] -command "$this linkrestore  ; ::destroy $m"
    if {[set ::${this}::deleted]} {
	set n 4
    } {
	set n 5
    }
    $m entryconfigure $n -state disabled
    $m add separator
    $m add command -label [mc Destroy] -command "$this linkdestroy ; ::destroy $m"
    tk_popup $m $x $y
    raise $m
}
#
proc otherEnd {this node} {
    switch $node [$this start] { return [$this end] }
    return [$this start]
}
#
proc unlink {this node tree} {
    set ::${this}::deleted 1
    if {$tree} {
	switch $node [$this start] {
	    switch -- [$this type] n - s { [$this end] unlink 1}
	}
    }
    [$this start] checkRooting
    [$this end] checkRooting
    if {[[set chrt [$this map]] showdeleted]} {
	[$chrt canvas] itemconfigure $this -fill [tkDarken [$this colour] 200]
    } {
	[$chrt canvas] delete $this
    }
}
#
proc relink {this node tree} {
    set ::${this}::deleted 0
    if {$tree} {
	switch $node [$this start] { [$this end] relink 1}
    }
    [$this start] checkRooting
    [$this end] checkRooting
    [[$this map] canvas] itemconfigure $this -fill [$this colour]
}
#
proc destroy {this node tree} {
    switch $node [$this start] {
	switch -- [$this type] n - s { 
	    if {$tree} {[$this end] destroy 1} { [$this end] removeLink $this }
	} default {
	    [$this end] removeLink $this
	}
    } default {
	[$this start] removeLink $this
    }
    $this delete
}
#
proc linkremove {this} {
    set ::${this}::deleted 1
    [$this start] checkRooting
    [$this end] checkRooting
    if {[[set chrt [$this map]] showdleted]} {
	[$chrt canvas] itemconfigure $this -fill [tkDarken [$this colour] 200]
    } {
	[$chrt canvas] delete $this
    }
}
#
proc linkrestore {this} {
    set ::${this}::deleted 0
    [$this start] checkRooting
    [$this end] checkRooting
    [[$this map] canvas] itemconfigure $this -fill [$this colour]
}
#
proc linkdestroy {this} {
    [$this start] deLink $this [$this type]
    [$this end] deLink $this [$this otherway [$this type]] 
    $this delete
}
#
proc mapNames {this} {
    set ::${this}::start [[$this map] nameMap([$this start])]
    set ::${this}::end [[$this map] nameMap([$this end])]
}
#
    proc addUserField {this pars str} { addUF $this $pars $str }
#
# End of link namespace
#
}

