#
# $Source: /home/nlfm/Working/Mercator/Released/lib/RCS/Object.tcl,v $
# $Date: 1999/12/10 09:25:06 $
# $Revision: 1.1.1.6 $
#
# ----------------------------------------------------------------------
#   AUTHOR:  Lindsay Marshall <lindsay.marshall@newcastle.ac.uk>
# ----------------------------------------------------------------------
# Copyright 1998 Lindsay F. Marshall (see COPYRIGHT)
# ======================================================================
#
package provide Object 1.0
#
proc class {name vars args} {
    global $name Private.$name
    upvar #0 Configure.$name Conf
    set $name {}
    foreach {x y z} $vars {
	lappend $name $x $y
	set Conf($x) $z
    }
    foreach {x y} [lindex $args 0] {
	lappend Private.$name $x $y
    }
}
namespace eval ::Object:: {
#
variable nameCount 0
#
proc objName {class} {
    global OType
    set n [::Object::newName $class]
    set OType($n) $class
    return $n
}
#
proc newName {thing} {
    return [string tolower $thing][incr ::Object::nameCount]
}
#
proc initObj {name args} {
    foreach x $args {
	namespace eval ::$name "variable [uplevel #0 set $x]"
	switch {} [set foo [uplevel #0 set Private.$x]] { } default {
	    namespace eval ::$name "variable $foo"
	}
    }
}
#
proc makeObj {types pars} {
    set mt [lindex $types end]
    set this [objName $mt]
    eval ::Object::initObj $this $types
    uplevel #0 set ::${this}::name $this
    set mt [string tolower $mt]
    switch {} [info proc ::${mt}::call] {
	namespace eval :: "proc $this {op args} {::Object::objCall $mt $this \$op \$args}"
    } default {
        namespace eval :: "proc $this {op args}  {::${mt}::call $this \$op \$args}"
    }
    switch {} $pars {} default { eval $this configure $pars }
    return $this
}
#
proc objCall {kind this op pars} {
    upvar #0 $this odata
    if {[info exists ::${this}::$op]} {return [set ::${this}::$op]}
    return [eval ::${kind}::$op $this $pars]
}
#
proc delete {this} {
    namespace eval :: " rename $this {} "
    namespace delete ::$this
    
}
#
proc save {object type desc} {
    global $type
    set values {}
    foreach {x y} [set $type] {
        switch -exact -- [set val [$object $x]] $y {} \
	default {
            lappend values $x $val
	}
    }
    puts $desc "#\n$type $object [list $values]"
}
#
proc confObj {this pars} {
    foreach {x y} $pars {
        namespace eval ::$this "set [string range $x 1 end] [list $y]"
    }
}
#
}
