#
# $Source: /home/nlfm/Working/Mercator/Released/lib/RCS/Style.tcl,v $
# $Date: 1999/12/10 09:25:06 $
# $Revision: 1.1.1.4 $
#
#
package provide Style 1.0
#
namespace eval ::Style {
    namespace export init
#
    variable ncount 0
#
    proc newStyle {chart} {
        variable workstyle
        variable workname
        global ns$chart
        set ns$chart {}
	set win [toplevel .@ns$chart]
	wm title $win "Create a New Style"
	grid columnconfigure $win 1 -weight 1
	grid [label $win.ln -text Name] -row 0 -column 0 -sticky w
	grid [entry $win.name] -row 0 -column 1
        grid [label $win.sl -text [mc "Based on style"]] \
	  -row 0 -column 0 -sticky w -padx 5
	set workstyle [set ::${chart}::currentstyle]
	set workname [set ${workstyle}::name]
        grid [menubutton $win.mb -textvariable ::Style::workname \
	    -indicatoron 1\
            -menu $win.mb.menu -relief raised -bd 2 -highlightthickness 2 \
	    -anchor c -direction flush -width 12] -row 0 -column 1 -sticky ew
        menu $win.mb.menu -tearoff 0
        foreach {i j} [set ::${chart}::styles] {
            $win.mb.menu add command -label [set ${i}::name] -command ""
        }
        set rw 1
        foreach x {font foreground background} {
	    incr rw
	    grid [label $win.l$x -text [mc [capitalise $x]]] -row $rw -sticky w -padx 5
	    incr rw
	    grid [frame $win.f$x] -row $rw -sticky ew -columnspan 2
	    grid columnconfigure $win.f$x 0 -weight 1
	    grid [entry $win.f$x.e] -sticky ew -padx 5
	    button $win.f$x.b -width 7 -text [mc Select]  
	    grid $win.f$x.b -row 0 -column 1
        }
        foreach x {foreground background} {
            $win.f$x.e insert insert [set ${::Style::workstyle}::$x]
        }
	grid [frame $win.btn] -rw [incr rw] -column 0 -columnspan 2 -sticky ew
	grid [button $win.btn.ok -text [mc OK]  -width 8 \
	  -command "set ns$chart \[::Style::create $win $chart\]"] \
	  [button $win.btn.cancel -text [mc Cancel] -width 8 -command "::destroy $win"]
	tkwait window $win
	set res [set ns$chart]
	unset ns$chart
	return $res
    }
    #
    proc create {win chart} {
        set ns [newStyleName]
        set nm [$win.name get]
        set fg [$win.fforeground.e get]
        set bg [$win.fbackground.e get]
        set ft [$win.ffont.e get]
        namespace eval $ns "
            variable name [list $nm]
            variable foreground [list $fg]
            variable background [list $bg]
        "
        catch {::destroy $win}
        return $ns
    }
    #
    proc newStyleName {} {
        variable ncount
        return ::Style::[incr ncount]
    }
    #
    proc makeStyle {name data} {
        set ns [newStyleName]
	namespace eval $ns "variable name [list $name]"
	foreach x [split $data ;] {
	    foreach {var val} [split $x :] break
	    namespace eval $ns "variable $var [list [string trim $val]]"
	}
	return $ns
    }
#
    proc ftCancel {} {
        destroy .ftsel
        uplevel #0 unset Family Size Weight Slant
    }
#
    proc ftOK {} {
        destroy .ftsel
    }
#
    proc fontSelector {ft} {
        global font Family Size Weight Slant
        array set fti [font actual $ft]
        set Family $fti(-family)
        set Size $fti(-size)
        set Weight $fti(-weight)
        set Slant $fti(-slant)
        toplevel .ftsel
        wm title .ftsel [mc {Font Selector}]
        eval tk_optionMenu .ftsel.family Family [font families]
        tk_optionMenu .ftsel.size Size 10 12 14 16 18 20 22 24 28 30
        tk_optionMenu .ftsel.weight Weight bold normal
        tk_optionMenu .ftsel.slant Slant roman italic oblique
        grid .ftsel.family -sticky ew
        grid .ftsel.size -sticky ew
        grid .ftsel.weight -sticky ew
        grid .ftsel.slant -sticky ew
        grid [label .ftsel.test -font $ft -relief ridge -bd 2 -text \
          "The quick brown fox jumps\nover the lazy dog. 0123456789" ] -sticky ew
        grid [frame .ftsel.btn]
        grid [button .ftsel.btn.can -text Cancel -command ::Style::ftCancel -width 7] \
          [button .ftsel.btn.ok -text ok -default active -command ::Style::ftOK \
          -width 7 ] -padx 5 -pady 5
        tkwait window .ftsel
        if {[info exists Family]} {
            set xx [list $Family $Size $Weight $Slant]
            uplevel #0 unset Family Size Weight Slant
            return $xx
        } {
            return {}
        }
    }
}
#
proc ::Style::init {} {
}
#
proc foregroundSelect {obj} {
    switch {} [set col [tk_chooseColor]] {} default {
        set ::${obj}::foreground $col
        $obj fmtconf foreground
    }
}
#
proc backgroundSelect {obj} {
    switch {} [set col [tk_chooseColor]] {} default {
        set ::${obj}::background $col
        $obj fmtconf background
   }
}
#
proc fontSelect {obj} {
    switch {} [set ft [::Style::fontSelector [[[$obj map] canvas].$obj.lb cget -font]]] {} default {
        $obj fmtconf font
    }
}
#
proc modfont {val inc} {
    array set fdt [font actual $val]
    set fdt(-size) [expr {$fdt(-size)+$inc}]
    set nm [list $fdt(-family) $fdt(-size)]
    switch  $fdt(-slant) roman {} default { lappend nm $fdt(-slant) }
    switch  $fdt(-weight) normal {} default { lappend nm $fdt(-weight) }
    return $nm 
}
#
proc shrinkfont {val} { return [modfont -6] }
#
proc growfont {val} { return [modfont $val 6] }
